<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                version="1.0">
  
  <!-- reorder <rmrs> daughter nodes according to RMRS DTD definition, -->
  <!-- and reorder rargs such that they appear in a logical order within one EP -->
  <!-- !! this stylesheet has to be adapted when DTD changes !! -->
  <!-- based on reorderrmrsdtrs.xsl by Ulrich.Schaefer@dfki.de -->

  <xsl:output method="xml" indent="yes"/>
  <xsl:strip-space elements="*"/>

  <xsl:template match="/pet|/rmrs-list">
    <!-- start at root element -->
    <xsl:copy select=".">
      <xsl:copy-of select="@*"/>
      <xsl:apply-templates select="*"/>
    </xsl:copy>
  </xsl:template>

  <xsl:template match="rmrs">
    <!-- special handling for <rmrs> daughter elements -->
    <!-- DTD fragment: ELEMENT rmrs (text?, label, ep*, rarg*, ing*, hcons*) -->
    <xsl:copy select=".">
      <xsl:apply-templates select="text"/>
      <xsl:apply-templates select="label"/>
      <xsl:apply-templates select="ep"/>
      <xsl:apply-templates select="rarg[rargname/text()='ARG1']"/>
      <xsl:apply-templates select="rarg[rargname/text()='ARG2']"/>
      <xsl:apply-templates select="rarg[rargname/text()='ARG3']"/>
      <xsl:apply-templates select="rarg[rargname/text()='ARGN']"/>
      <xsl:apply-templates select="rarg[rargname/text()='RSTR']"/>
      <xsl:apply-templates select="rarg[rargname/text()='BODY']"/>
      <xsl:apply-templates select="rarg[rargname/text()='L_INDEX']"/>
      <xsl:apply-templates select="rarg[rargname/text()='L_HNDL']"/>
      <xsl:apply-templates select="rarg[rargname/text()='R_INDEX']"/>
      <xsl:apply-templates select="rarg[rargname/text()='R_HNDL']"/>
      <xsl:apply-templates select="rarg[rargname/text()='TPC']"/>
      <xsl:apply-templates select="rarg[rargname/text()='SUBORD']"/>
      <xsl:apply-templates select="rarg[rargname/text()='CARG']"/>
      <xsl:apply-templates select="rarg[rargname/text()='MARG']"/>
      <xsl:apply-templates select="ing"/>
      <xsl:apply-templates select="hcons"/>
    </xsl:copy>
  </xsl:template>

  <xsl:template match="ep|hcons|text|c|label|rarg|rargname|constant|ing|ing-a|ing-b|metadata|conf|id|entry|gpred|realpred|var|hi|lo">
    <!-- copy all other nodes -->
    <xsl:copy-of select="."/>
  </xsl:template>

</xsl:stylesheet>
